from direct.gui.DirectGui import *

#TODO: make frames for each mode, and use show/hide
class MultiplayerMenu:
    def __init__(self, parent, params):
        self.params = params
        self.parent = parent
        self.mainFrame = DirectFrame(
                                     frameColor=(0,0,0,1), 
                                     frameSize=(-0.5,0.5,0,0.9)
                                     )
        self.server = DirectButton(
                                   parent = self.mainFrame,
                                   text = ("Host LAN"), 
                                   pos = (-0.3,0,0.8),
                                   scale=.05,
                                   command=self.serverPressed
                                   )
        self.client = DirectButton(
                                   parent = self.mainFrame, 
                                   text = ("Join LAN"), 
                                   pos = (-0.1,0,0.8),
                                   scale=.05,
                                   command=self.clientPressed
                                   )    
        self.el1 = None
        self.el2 = None
        self.el3 = None
        self.el4 = None
        self.el5 = None
        self.mode = 0
        self.serverPressed()
        self.hide()
     
    def hide(self):
        self.mainFrame.hide()
        
    def show(self):
        self.mainFrame.show()   
        
    def __del__(self):
        self.mainFrame.destroy()
        self.server.destroy()
        self.client.destroy()
        if not self.el1 == None:
            self.el1.destroy()
        if not self.el2 == None:
            self.el2.destroy()
        if not self.el3 == None:
            self.el3.destroy()
        if not self.el4 == None:
            self.el4.destroy()
        if not self.el5 == None:
            self.el5.destroy()
        
    def serverPressed(self):
        if self.mode==1:
            return
        self.mode = 1
        
        if self.el1:
            self.el1.destroy()
        if self.el2:
            self.el2.destroy()
        if self.el3:
            self.el3.destroy()
        if self.el4:
            self.el4.destroy()
        if self.el5:
            self.el5.destroy()
        self.el1 = DirectLabel(
                               parent = self.mainFrame, 
                               text = "Port:", 
                               pos = (-0.4,0,0.6),
                               scale = 0.06
                               )
        self.el2 = DirectEntry(
                               parent = self.mainFrame, 
                               text = "",
                               scale=.05,
                               pos = (-0.3,0,0.6), 
                               initialText=self.params.get("networkPort")
                               )
        self.el3 = DirectButton(
                                parent = self.mainFrame, 
                                text = ("Host"), 
                                pos = (0,0,0.3),
                                scale=.05,
                                command=self.serverStart
                                )
        
    def serverStart(self):
        self.params.set("networkPort",self.el2.get())
        self.parent.serverStart()
    
    def clientPressed(self):
        if self.mode==2:
            return
        self.mode = 2
        
        if self.el1:
            self.el1.destroy()
        if self.el2:
            self.el2.destroy()
        if self.el3:
            self.el3.destroy()
        self.el1 = DirectLabel(
                               parent = self.mainFrame, 
                               text = "Port:", 
                               pos = (-0.4,0,0.6),
                               scale = 0.06
                               )
        self.el2 = DirectEntry(
                               parent = self.mainFrame, 
                               text = "",
                               scale=.05,
                               pos = (-0.3,0,0.6), 
                               initialText=self.params.get("networkPort")
                               )
        self.el3 = DirectLabel(
                               parent = self.mainFrame, 
                               text = "Ip:", 
                               pos = (-0.4,0,0.4),
                               scale = 0.06
                               )
        self.el4 = DirectEntry(
                               parent = self.mainFrame, 
                               text = "",
                               scale=.05,
                               pos = (-0.3,0,0.4), 
                               initialText=self.params.get("networkIp")
                               )
        self.el5 = DirectButton(
                                self.mainFrame, 
                                text = ("Join"), 
                                pos = (0,0,0.2),
                                scale=.05,
                                command=self.serverJoin
                                )

    def serverJoin(self):
        self.params.set("networkPort", self.el2.get())
        self.params.set("networkIp", self.el4.get())
        self.parent.serverJoin()
 