from direct.gui.DirectGui import *

DIRECTORY = 'data/gui/textures/'

VERTICALSCROLL_FRAMETEXTURE             = loader.loadTexture( DIRECTORY+'scrollVerticalBorder.png' )
VERTICALSCROLL_INCBUTTON_FRAMETEXTURE   = loader.loadTexture( DIRECTORY+'scrollVerticalDown.png' )
VERTICALSCROLL_DECBUTTON_FRAMETEXTURE   = loader.loadTexture( DIRECTORY+'scrollVerticalUp.png' )
VERTICALSCROLL_TUMB_FRAMETEXTURE        = loader.loadTexture( DIRECTORY+'scrollVerticalBar.png' )

#TODO: make multiframe
# add keibindings
# add graphics

class OptionsMenu:
    def __init__(self, parent, params):
        self.parent = parent
        self.params = params
        self.mainFrame = DirectScrolledFrame(
                                                frameColor=(0,0,0,1), 
                                                canvasSize = (-0.45,0.45,-2,2), 
                                                frameSize=(-0.5,0.5,-0.6,0.9 ),
                                                
                                                verticalScroll_resizeThumb              = False,
                                                
                                                verticalScroll_frameTexture             = VERTICALSCROLL_FRAMETEXTURE,
                                                verticalScroll_incButton_frameTexture   = VERTICALSCROLL_INCBUTTON_FRAMETEXTURE,
                                                verticalScroll_decButton_frameTexture   = VERTICALSCROLL_DECBUTTON_FRAMETEXTURE,
                                                verticalScroll_thumb_frameTexture       = VERTICALSCROLL_TUMB_FRAMETEXTURE,
                                                
                                                verticalScroll_relief                   = DGG.FLAT,
                                                verticalScroll_thumb_relief             = DGG.FLAT,
                                                verticalScroll_decButton_relief         = DGG.FLAT,
                                                verticalScroll_incButton_relief         = DGG.FLAT,
                                             ) 
        self.test = DirectButton(
                                 parent = self.mainFrame.getCanvas(), 
                                 text = ("back"), 
                                 scale=.05,
                                 pos = (0,0,0.8),
                                 command=self.back
                                 )
        
        self.menu = DirectOptionMenu(
                                     parent = self.mainFrame.getCanvas(),
                                     text="options", 
                                     scale=0.1,
                                     items=["800x600",
                                            "1024x768",
                                            "1152x864",
                                            "1280x960",
                                            "1280x1024",
                                            "1440x900",
                                            "1600x900",
                                            "1680x1050"],
                                     initialitem=2,
                                     highlightColor=(0.65,0.65,0.65,1),
                                     command=self.itemSel,
                                     extraArgs=['res'])
        
        
        
        self.hide()
    
    def itemSel(self, arg, what):
        output = "Item Selected is: "+arg
        #textObject.setText(output)
    
    def hide(self):
        self.mainFrame.hide()
        
    def show(self):
        self.mainFrame.show()
    
    def __del__(self):
        self.mainFrame.destroy()
        
    def back(self):
        self.hide()
        self.parent.show();
        
'''class OptionsMaker:
    def __init__(self):
        print "__INIT__";
        
        types:
            scroll
            check
            select
        items:
            cation
            type
            values'''
            
        